searchNodes=[{"doc":"Blogs, docs, and static pages in Phoenix. Check out the README to get started. Options :otp_app - The name of the OTP application to use as the base directory when looking for page files. This value is required. :render_options - Allows the renderers to be configured. See pages/4 for the options.","ref":"PhoenixPages.html","title":"PhoenixPages","type":"behaviour"},{"doc":"Gets a list of pages for a given ID. See the :id option in pages/4 . This can be used to get a list of pages from within a controller for index pages or further customization such as finding related pages, filtering by a value, etc. Returns {:ok, pages} if successful, or :error if no pages were defined with the ID.","ref":"PhoenixPages.html#c:get_pages/1","title":"PhoenixPages.get_pages/1","type":"callback"},{"doc":"Same as get_pages/1 , but will raise PhoenixPages.NotFoundError if no pages were defined with the ID.","ref":"PhoenixPages.html#c:get_pages!/1","title":"PhoenixPages.get_pages!/1","type":"callback"},{"doc":"Finds all the pages matching a pattern and generates a GET route for each one. Options :id - The ID for this collection of pages so they can later be accessed with get_pages/1 and get_pages!/1 . This is only required if using those functions. :from - The wildcard pattern used to look for pages on the filesystem. Make sure the base directory is included in your release ( priv is included by default). Defaults to priv/pages/**/*.md . :sort - The order of the pages returned when using get_pages/1 and get_pages!/1 . Defined as a tuple with the first element being an atom for the sort value (which can be any value from the attributes), and the second element being either :asc or :desc . :attrs - A list of attributes used when parsing the markdown frontmatter for each page. Atoms will be required for each page, key values will be optional with a default value. Defaults to [] . :render_options - Allows the renderers to be configured. This can also be set globally in the module options . :markdown - Allows the Earmark renderer to be configured. :hard_breaks - Whether to convert hard line breaks to &lt;br&gt; tags. Defaults to false . :wiki_links - Whether to enable wiki-style links such as [[page]] . Defaults to true . :pure_links - Whether to convert raw URLs to &lt;a&gt; tags. Defaults to true . :sub_sup - Whether to convert ~x~ and ^x^ to &lt;sub&gt; and &lt;sup&gt; tags. Defaults to true . :footnotes - Whether to enable footnotes. Defaults to true . :smartypants - Whether to enable smartypants . Defaults to true . :compact_output - Whether to avoid indentation and minimize whitespace in output. Defaults to false . :escape_html - Whether to allow raw HTML in markdown. Defaults to false . :syntax_highlighting - Whether to enable Makeup syntax highlighting. Defaults to true . :code_class_prefix - A class prefix to add to the language class of code blocks. All other options are passed to Phoenix.Router.match/5","ref":"PhoenixPages.html#pages/4","title":"PhoenixPages.pages/4","type":"macro"},{"doc":"","ref":"PhoenixPages.html#t:page/0","title":"PhoenixPages.page/0","type":"type"},{"doc":"","ref":"PhoenixPages.Page.html","title":"PhoenixPages.Page","type":"module"},{"doc":"","ref":"PhoenixPages.Page.html#t:t/0","title":"PhoenixPages.Page.t/0","type":"type"},{"doc":"Exception raised when get_pages/1 or get_pages!/1 is called with an ID that was not found.","ref":"PhoenixPages.NotFoundError.html","title":"PhoenixPages.NotFoundError","type":"exception"},{"doc":"Exception raised when a page's frontmatter cannot be parsed.","ref":"PhoenixPages.ParseError.html","title":"PhoenixPages.ParseError","type":"exception"},{"doc":"Create blogs, documentation sites, and other static pages in Phoenix. This library integrates seamlessly into your router and comes with built-in support for rendering markdown with frontmatter, syntax highlighting, compile-time caching, and more. Getting Started Formatting Frontmatter Syntax Highlighting Index Pages Defining Paths Extended Markdown Local Development","ref":"readme.html","title":"README","type":"extras"},{"doc":"def deps do [ { :phoenix_pages , &quot;~&gt; 0.1&quot; } ] end The recommended way to install into your Phoenix application is to add this to your router function in lib/myapp_web.ex , replacing myapp with the name of your application: def router do quote do use Phoenix.Router , helpers : false use PhoenixPages , otp_app : :myapp # ... end end Now you can add a new route using the pages/4 macro: scope &quot;/&quot; , MyAppWeb do pipe_through :browser get &quot;/&quot; , PageController , :home pages &quot;/:page&quot; , PageController , :show , from : &quot;priv/pages/**/*.md&quot; end This will read all the markdown files from priv/pages and create a new GET route for each one. The :page segment will be replaced with the path and filename (without the extension) relative to the base directory (see Defining Paths ). You'll also need to add the :show handler to lib/myapp_web/controllers/page_controller.ex : defmodule MyAppWeb.PageController do use MyAppWeb , :controller # ... def show ( conn , _params ) do render ( conn , &quot;show.html&quot; ) end end Lastly, add a template at lib/myapp_web/controllers/page_html/show.html.heex . The page's rendered markdown will be available in the inner_content assign: &lt; main &gt; &lt;%= @inner_content %&gt; &lt;/ main &gt; That's it! Now try creating a file at priv/pages/hello.md and visiting /hello .","ref":"readme.html#getting-started","title":"README - Getting Started","type":"extras"},{"doc":"To prevent mix format from adding parenthesis to the pages macro similar to the other Phoenix Router macros, add :phoenix_pages to .formatter.exs : [ import_deps : [ :ecto , :ecto_sql , :phoenix , :phoenix_pages ] ]","ref":"readme.html#formatting","title":"README - Formatting","type":"extras"},{"doc":"Frontmatter allows page-specific variables to be included at the top of a markdown file using the YAML format. If you're setting frontmatter variables (which is optional), they must be the first thing in the file and must be set between triple-dashed lines: --- title: Hello World --- Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. To specify which frontmatter values are expected in each page, set the attrs option: pages &quot;/:page&quot; , PageController , :show , from : &quot;priv/pages/**/*.md&quot; , attrs : [ :title , author : nil ] Atom values will be considered required, and a compilation error will be thrown if missing from any of the pages. Key-values must come last in the list, and will be considered optional by defining a default value. Any frontmatter values not defined in the attributes list will be silently discarded. Valid attribute values will be available in the assigns: &lt; main &gt; &lt; h1 &gt; &lt;%= @title %&gt; &lt;/ h1 &gt; &lt; h2 :if = { @author } &gt; &lt;%= @author %&gt; &lt;/ h2 &gt; &lt;%= @inner_content %&gt; &lt;/ main &gt;","ref":"readme.html#frontmatter","title":"README - Frontmatter","type":"extras"},{"doc":"Phoenix Pages uses the Makeup project for syntax highlighting. To enable, import a theme listed below into your CSS bundle. The specifics of doing this highly depend on your CSS configuration, but a few examples are included below. In most cases, you will need to import phoenix_pages/css/monokai.css (or whatever theme you choose) into your bundle and ensure deps is included as a vendor directory. Themes abap algol algol_nu arduino autumn black_white borland colorful default emacs friendly fruity igor lovelace manni monokai murphy native paraiso_dark paraiso_light pastie perldoc rainbow_dash rrt samba tango trac vim visual_studio xcode Next, add a Makeup lexer for your specific language(s) to the project dependencies. Phoenix Pages will pick up the new dependency and start highlighting your code blocks without any further configuration. No lexers are included by default. Lexers C - `{:makeup_c, \"~> 0.0\"}` Diff - `{:makeup_diff, \"~> 0.0\"}` Elixir - `{:makeup_elixir, \"~> 0.0\"}` Erlang - `{:makeup_erlang, \"~> 0.0\"}` GraphQL - `{:makeup_graphql, \"~> 0.0\"}` (H)EEx - `{:makeup_eex, \"~> 0.0\"}` HTML - `{:makeup_html, \"~> 0.0\"}` Javascript - `{:makeup_js, \"~> 0.0\"}` JSON - `{:makeup_json, \"~> 0.0\"}` Rust - `{:makeup_rust, \"~> 0.0\"}` SQL - `{:makeup_sql, \"~> 0.0\"}` If your language of choice isn't supported, consider writing a new Makeup lexer to contribute to the community. Otherwise, you can use a JS-based syntax highlighter such as highlight.js by setting code_class_prefix: &quot;language-&quot; and syntax_highlighting: false in render_options . ESBuild Example Using the ESBuild installer , add the env option to config/config.exs : config :esbuild , version : &quot;0.17.18&quot; , default : [ cd : Path . expand ( &quot;../assets&quot; , __DIR__ ) , env : %{ &quot;NODE_PATH&quot; =&gt; Path . expand ( &quot;../deps&quot; , __DIR__ ) } , args : ~w(--bundle --outdir=../priv/static/assets js/app.js) ] Then in app.js : import &quot;phoenix_pages/css/monokai.css&quot; ; Sass Example Using the Sass installer , add the --load-path flag to config/config.exs : config :dart_sass , version : &quot;1.62.0&quot; , default : [ cd : Path . expand ( &quot;../assets&quot; , __DIR__ ) , args : ~w(--load-path=../deps css/app.scss ../priv/static/assets/app.css) ] Then in app.scss : @import &quot;phoenix_pages/css/monokai&quot;; Tailwind Example Install the postcss-import plugin as described here and add the following to assets/postcss.config.js : module . exports = { plugins : { &quot;postcss-import&quot; : { } } } Then in app.css : @import &quot;../../deps/phoenix_pages/css/monokai&quot;;","ref":"readme.html#syntax-highlighting","title":"README - Syntax Highlighting","type":"extras"},{"doc":"To create an index page with links to all the other pages, create a normal GET route and use the id option alongside get_pages/1 and get_pages!/1 : get &quot;/blog&quot; , BlogController , :index pages &quot;/blog/:page&quot; , BlogController , :show , id : :blog , from : &quot;priv/blog/**/*.md&quot; , attrs : [ :title , :author , :date ] defmodule MyAppWeb.BlogController do use MyAppWeb , :controller def index ( conn , _params ) do pages = MyAppWeb.Router . get_pages! ( :blog ) conn |&gt; assign ( :pages , pages ) |&gt; render ( &quot;index.html&quot; ) end def show ( conn , _params ) do render ( conn , &quot;show.html&quot; ) end end &lt; .link :for = { page &lt;- @pages } navigate = { page . path } &gt; &lt;%= page . assigns . title %&gt; &lt;/ .link &gt; Sorting The pages returned from the get_pages functions will be sorted by filename. If you want to specify a different order during compilation rather than in the controller on every page load, use the sort option: pages &quot;/blog/:page&quot; , BlogController , :show , id : :blog , from : &quot;priv/blog/**/*.md&quot; , attrs : [ :title , :author , :date ] , sort : { :date , :desc } Any attribute value from the frontmatter can be defined as the sort value.","ref":"readme.html#index-pages","title":"README - Index Pages","type":"extras"},{"doc":"When defining the pages path, the :page segment will be replaced for each generated page during compilation with the values derived from ** and * . This is different than segments in regular routes, which are parsed during runtime into the params attribute of the controller function. For example, let's say you have the following file structure: ├ ─ ─ priv / │ ├ ─ ─ pages / │ │ ├ ─ ─ foo . md │ │ ├ ─ ─ bar / │ │ │ ├ ─ ─ baz . md Defining pages &quot;/:page&quot;, from: &quot;priv/pages/**/*.md&quot; in your router will create two routes: get &quot;/foo&quot; and get &quot;/bar/baz&quot; . You can even put the :page segment somewhere else in the path, such as /blog/:page , and it will work as expected creating get &quot;/blog/foo&quot; and get &quot;/blog/bar/baz&quot; . Capture Groups For complex scenarios, you have the option of using capture group variables instead of the :page segment. Let's say you have the same file structure as above, but don't want the baz path to be nested under /bar . You could define pages &quot;/$2&quot;, from: &quot;priv/pages/**/*.md&quot; , using $2 instead of :page . This will create two routes: get &quot;/foo&quot; and get &quot;/bar&quot; . Capture group variables will contain the value of the ** and * chunks in order, starting at $1 . Keep in mind that ** will match all files and zero or more directories and subdirectories, and * will match any number of characters up to the end of the filename, the next dot, or the next slash. For more info on the wildcard patterns, check out Path.wildcard/2 .","ref":"readme.html#defining-paths","title":"README - Defining Paths","type":"extras"},{"doc":"In addition to the customizable markdown options , markdown rendering also supports IAL attributes by default. Meaning you can add HTML attributes to any block-level element using the syntax {:attr} . For example, to create a rendered output of &lt;h1 class=&quot;foobar&quot;&gt;Header&lt;/h1&gt; : # Header{:.foobar} Attributes can be one of the following: {:#id} to define an ID {:.className} to define a class name {:name=value} , {:name=&quot;value&quot;} , or {:name='value'} to define any other attribute To define multiple attributes, separate them with spaces: {:#id name=value} .","ref":"readme.html#extended-markdown","title":"README - Extended Markdown","type":"extras"},{"doc":"If you add, remove, or change pages while running mix phx.server , they will automatically be replaced in the cache and you don't have to restart for them to take effect. To live reload when a page changes, add to the patterns list of the Endpoint config in config/dev.exs : config :myapp , MyAppWeb.Endpoint , live_reload : [ patterns : [ ~r&quot;priv/pages/.*(md)$&quot; , # ... ] ]","ref":"readme.html#local-development","title":"README - Local Development","type":"extras"}]